  member
  include('WinEquMG.clw') !try include('svapi.inc') available in C6


PSECURITY_DESCRIPTOR PVOID

SECURITY_ATTRIBUTES group,type
nLength               DWORD
lpSecurityDescriptor  LPVOID
bInheritHandle        BOOL
                    end


ERROR_SUCCESS               Equate(  0) !from WinError.h
NO_ERROR                    Equate(  0) !from Error.h
ERROR_ACCESS_DENIED         Equate(  5) !from Error.h
ERROR_INVALID_HANDLE        Equate(  6) !form Error.h
ERROR_ALREADY_EXISTS        Equate(183) !from Error.h

INVALID_HANDLE_VALUE        Equate( -1) !from MapiWin.h

WinAPI_NULL                 Equate(  0)


LPCTSTR                     Equate(long) !usage  Address( myCstring)

ANSI_or_UNICODE             Equate('A')

 map
   module('win32')
     CloseHandle (Handle hObject                                            ),Bool  ,pascal,raw !,name('CloseHandle')  !returns non-zero on success, use GetLastError on zero
     GetLastError(                                                          ),DWORD ,pascal,raw !,name('getlasterror')
     CreateMutex (Long lpMutexAttributes, BOOL bInitialOwner, LPCTSTR lpName),HANDLE,pascal,raw,Name('CreateMutex' & ANSI_or_UNICODE)
     GetSystemMetrics( SIGNED nIndex                                        ),SIGNED,pascal,raw

   end
 end !map

 include('ctMutex.inc'),once


!--------------------------------------------------------------
ctMutex.Construct Procedure
  code
  self.MutexName   = all('0',size(self.MutexName))
  self.MutexHandle = INVALID_HANDLE_VALUE
  self.LastError   = NO_ERROR

!--------------------------------------------------------------
ctMutex.Destruct Procedure
  code
  self.Kill()


!--------------------------------------------------------------
ctMutex.Init     Procedure(string argMutexName) !,Bool
lclRetVal  Bool(False)
  code
  if self.MutexHandle <> INVALID_HANDLE_VALUE
     Message('ctMutex.Init('& clip(argMutexName) &') called when MutexHandle['& self.MutexHandle &']')
  else
     Self.MutexName   = argMutexName
     if len(clip(argMutexName)) + 1 > size(Self.MutexName)
        !todo complain
        Self.MutexName[ size(Self.MutexName) ] = '<0>'
     end
     Self.MutexHandle = CreateMutex(WinAPI_NULL, FALSE, address( self.MutexName ))
     Self.LastError   = GetLastError()
     case Self.LastError
       of ERROR_SUCCESS       ; lclRetVal = TRUE !No Errors
   !   of ERROR_ALREADY_EXISTS
   ! orof ERROR_ACCESS_DENIED ;
   !  of ERROR_INVALID_HANDLE ;
     else
          Self.Kill()
     end
  end
  return lclRetVal

!--------------------------------------------------------------
ctMutex.Kill     Procedure()
  code
  if self.MutexHandle <> INVALID_HANDLE_VALUE
     if not CloseHandle( self.MutexHandle )
           Self.LastError = GetLastError()
           !todo, show the error message
     else  Self.LastError = NO_ERROR
     end
    !self.ClearProperties() !no, want to leave LastError around
     self.MutexHandle =  INVALID_HANDLE_VALUE
  end



!=============================================================================
!=============================================================================
!=============================================================================
!=============================================================================
ctTSEMutex.Init           Procedure(string argMutexName)!,Bool
 code
 if self.NeedsGlobal()
    return parent.Init('Global\' & argMutexName)
 else
    return parent.Init(            argMutexName)
 end

!--------------------------------------------------------------
ctTSEMutex.NeedsGlobal    Procedure() !,byte
SM_REMOTESESSION          EQUATE(01000h)
lclRetVal                 Byte(False)

 code
 if GetSystemMetrics( SM_REMOTESESSION )
    lclRetVal = TRUE

 !see code on dell2000\\c\cla\download\attryde\GetOsVer.clw
 !elsif OS:Type = PlatForm_WinNT and Band( OS:ProductOption, ProductOption_Suite_Ts
    !info from Paul Attryde:
    ! could still be in a remote session, if running NT4 TSE w/SP1,2 or 3
    ! in which case he recommends that the user should upgrade anyway

 end

 return lclRetVal

